org.apache.xml.utils

## Class SuballocatedByteVector

- java.lang.Object
- - org.apache.xml.utils.SuballocatedByteVector

-     public class SuballocatedByteVector
      extends java.lang.Object

  A very simple table that stores a list of byte. Very similar API to our IntVector class (same API); different internal storage. This version uses an array-of-arrays solution. Read/write access is thus a bit slower than the simple IntVector, and basic storage is a trifle higher due to the top-level array -- but appending is O(1) fast rather than O(N**2) slow, which will swamp those costs in situations where long vectors are being built up. Known issues: Some methods are private because they haven't yet been tested properly. If an element has not been set (because we skipped it), its value will initially be 0. Shortening the vector does not clear old storage; if you then skip values and setElementAt a higher index again, you may see old data reappear in the truncated-and-restored section. Doing anything else would have performance costs.
  Usage:
    **For internal use only**

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SuballocatedByteVector()` Default constructor.
    `SuballocatedByteVector(int blocksize)` Construct a ByteVector, using the given block size.
    `SuballocatedByteVector(int blocksize, int increaseSize)` Construct a ByteVector, using the given block size.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addElement(byte value)` Append a byte onto the vector.
    `byte` | `elementAt(int i)` Get the nth element.
    `int` | `indexOf(byte elem)` Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
    `int` | `indexOf(byte elem, int index)` Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
    `void` | `removeAllElements()` Wipe it out.
    `void` | `setElementAt(byte value, int at)` Sets the component at the specified index of this vector to be the specified object.
    `int` | `size()` Get the length of the list.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SuballocatedByteVector

          public SuballocatedByteVector()

      Default constructor. Note that the default block size is very small, for small lists.

    - #### SuballocatedByteVector

          public SuballocatedByteVector(int blocksize)

      Construct a ByteVector, using the given block size.
      Parameters:
        `blocksize` - Size of block to allocate

    - #### SuballocatedByteVector

          public SuballocatedByteVector(int blocksize,
                                        int increaseSize)

      Construct a ByteVector, using the given block size.
      Parameters:
        `blocksize` - Size of block to allocate

  - ### Method Detail

    - #### size

          public int size()

      Get the length of the list.
      Returns:
        length of the list

    - #### addElement

          public void addElement(byte value)

      Append a byte onto the vector.
      Parameters:
        `value` - Byte to add to the list

    - #### removeAllElements

          public void removeAllElements()

      Wipe it out.

    - #### setElementAt

          public void setElementAt(byte value,
                                   int at)

      Sets the component at the specified index of this vector to be the specified object. The previous component at that position is discarded. The index must be a value greater than or equal to 0 and less than the current size of the vector.
      Parameters:
        `value` -
        `at` - Index of where to set the object

    - #### elementAt

          public byte elementAt(int i)

      Get the nth element. This is often at the innermost loop of an application, so performance is critical.
      Parameters:
        `i` - index of value to get
      Returns:
        value at given index. If that value wasn't previously set, the result is undefined for performance reasons. It may throw an exception (see below), may return zero, or (if setSize has previously been used) may return stale data.
      Throws:
        `java.lang.ArrayIndexOutOfBoundsException` - if the index was _clearly_ unreasonable (negative, or past the highest block).
        `java.lang.NullPointerException` - if the index points to a block that could have existed (based on the highest index used) but has never had anything set into it. %REVIEW% Could add a catch to create the block in that case, or return 0. Try/Catch is _supposed_ to be nearly free when not thrown to. Do we believe that? Should we have a separate safeElementAt?

    - #### indexOf

          public int indexOf(byte elem,
                             int index)

      Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
      Parameters:
        `elem` - object to look for
        `index` - Index of where to begin search
      Returns:
        the index of the first occurrence of the object argument in this vector at position index or later in the vector; returns -1 if the object is not found.

    - #### indexOf

          public int indexOf(byte elem)

      Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
      Parameters:
        `elem` - object to look for
      Returns:
        the index of the first occurrence of the object argument in this vector at position index or later in the vector; returns -1 if the object is not found.

Copyright © 2023 Apache XML Project. All Rights Reserved.